import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { DealerCapital, DealerCapitalParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询分销商资金明细表
 */
export async function pageDealerCapital(params: DealerCapitalParam) {
  const res = await request.get<ApiResult<PageResult<DealerCapital>>>(
    MODULES_API_URL + '/shop/dealer-capital/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询分销商资金明细表列表
 */
export async function listDealerCapital(params?: DealerCapitalParam) {
  const res = await request.get<ApiResult<DealerCapital[]>>(
    MODULES_API_URL + '/shop/dealer-capital',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加分销商资金明细表
 */
export async function addDealerCapital(data: DealerCapital) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-capital',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改分销商资金明细表
 */
export async function updateDealerCapital(data: DealerCapital) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-capital',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除分销商资金明细表
 */
export async function removeDealerCapital(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-capital/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除分销商资金明细表
 */
export async function removeBatchDealerCapital(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-capital/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询分销商资金明细表
 */
export async function getDealerCapital(id: number) {
  const res = await request.get<ApiResult<DealerCapital>>(
    MODULES_API_URL + '/shop/dealer-capital/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
